routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\ClassRoomController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GradeController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\StudentController;
use App\Http\Controllers\SubjectController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//> frontoffice
Route::get('/',[HomeController::class,'index'])->name('homepage.index');
Route::get('/student',[HomeController::class,'student'])->name('homepage.student');
Route::get('/student/{id}',[HomeController::class,'studentShow'])->name('homepage.student.show');

//> backoffice
Route::prefix("/dashboard")->middleware(['auth'])->group(function(){

    Route::get('/',[DashboardController::class,'index'])->name('dashboard.index');

    //> Core module
    Route::resource('classroom',ClassRoomController::class)->except('show');
    Route::resource('subject',SubjectController::class)->except('show');
    Route::resource('student',StudentController::class);
    Route::resource('grade',GradeController::class)->only(['create','store','update','edit']);

    Route::get("/logout",[AuthController::class,'logout'])->name('logout');
});

//> Auth
Route::middleware(['guest'])->group(function () {

    Route::get('/login', [AuthController::class, 'index'])->name('login');
    Route::post('/login', [AuthController::class, 'authenticate'])->name('login');
});

app/Models/Student.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Student extends Model
{
    use HasFactory;

    protected $fillable = ['classroom_id','name'];
    

    public function classroom()
    {
        return $this->belongsTo(ClassRoom::class);
    }

    public function grades()
    {
        return $this->hasMany(Grade::class);
    }
    

}

app/Http/Controllers/StudentController.php
<?php

namespace App\Http\Controllers;

use App\Models\ClassRoom;
use App\Models\Student;
use App\Models\Subject;
use Illuminate\Http\Request;

class StudentController extends Controller
{
    public function index()
    {
        $data = Student::with(['grades','classroom'])->orderBy('name')->get();
        $total_subject = Subject::count();

        return view('backoffice.student.index', compact('data','total_subject'));
    }

    public function create()
    {
        $classrooms = ClassRoom::get();
        return view('backoffice.student.create', compact('classrooms'));
    }

    public function store(Request $request)
    {
        $attr = $request->validate([
            'name' => 'required',
            'classroom_id' => 'required'
        ]);

        Student::create($attr);
        return redirect()->route('student.index')->with('msg', 'Data berhasil ditambahkan');
    }
    public function edit($id)
    {
        $classrooms = ClassRoom::get();
        $data = Student::findOrFail($id);
        return view('backoffice.student.edit', compact('classrooms', 'data'));
    }

    public function update($id, Request $request)
    {
        $data = Student::findOrFail($id);
        $attr = $request->validate([
            'name' => 'required',
            'classroom_id' => 'required'
        ]);

        $data->update($attr);
        return redirect()->route('student.index')->with('msg', 'Data berhasil ditambahkan');
    }

    public function show($id)
    {
        $data = Student::find($id);
        $total_subject = Subject::count();
        return view('backoffice.student.show', compact('data','total_subject'));
    }
    public function destroy($id)
    {
        Student::destroy($id);
        return redirect()->route('student.index')->with('msg', 'Data berhasil dihapus');
    }
}

resources/views/backoffice/student/create.blade.php
@extends('layouts.backoffice')
@section('title', 'Tambah Data')
@section('content')

    <div class="container-fluid p-4">
        <h4 class="mt-4">Tambah data</h4>

        <div class="container p-3">

            <form method="POST" action="{{ route('student.store') }}">
                @csrf
                <div class="mb-3">
                    <label class="form-label">Nama lengkap</label>
                    <input type="text" name="name" autocomplete="off" class="form-control">
                    @error('name')
                        <small class="text-danger"> {{ $message }}</small>
                    @enderror
                </div>
                <div class="mb-3">
                    <label id="classroom" class="form-label">Kelas</label>
                    <select class="form-control" name="classroom_id" id="classroom">
                        <option value=""> -- Pilih Kelas --</option>
                        @foreach ($classrooms as $item)
                            <option value="{{ $item->id }}">{{ $item->name }}</option>
                        @endforeach
                    </select>
                    @error('classroom_id')
                        <small class="text-danger"> {{ $message }}</small>
                    @enderror
                </div>

                <button type="submit" class="btn btn-primary">Simpan</button>
            </form>
        </div>
    </div>
@endsection

resources/views/backoffice/student/edit.blade.php
@extends('layouts.backoffice')
@section('title', 'Edit Data')
@section('content')

    <div class="container-fluid p-4">
        <h4 class="mt-4">Edit data</h4>

        <div class="container p-3">

            <form method="POST" action="{{ route('student.update', $data->id) }}">
                @csrf
                @method('put')
                <div class="mb-3">
                    <label class="form-label">Nama lengkap</label>
                    <input type="text" name="name" autocomplete="off" value="{{ $data->name }}" class="form-control">
                    @error('name')
                        <small class="text-danger"> {{ $message }}</small>
                    @enderror
                </div>
                <div class="mb-3">
                    <label id="classroom" class="form-label">Kelas</label>
                    <select class="form-control" name="classroom_id" id="classroom">
                        <option value=""> -- Pilih Kelas --</option>
                        @foreach ($classrooms as $item)
                            <option value="{{ $item->id }}" {{ $data->classroom_id == $item->id ? 'selected' : '' }}>
                                {{ $item->name }}</option>
                        @endforeach
                    </select>
                    @error('classroom_id')
                        <small class="text-danger"> {{ $message }}</small>
                    @enderror
                </div>

                <button type="submit" class="btn btn-primary">Simpan</button>
            </form>
        </div>
    </div>
@endsection

resources/views/backoffice/student/index.blade.php
@extends('layouts.backoffice')
@section('title', 'Data siswa')
@section('content')

    <div class="container-fluid p-4">
        <h4 class="mt-4">Data siswa</h4>
        @if (session()->has('msg'))
            
        <div class="alert alert-success alert-dismissible fade show" role="alert">
            {{ session()->get('msg')}}
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
        @endif
        <div class="row justify-content-end my-3">
        
            <div class="col-lg-2">

                <a href="{{ route('student.create') }}" class="btn btn-primary"> <i class="fa fa-plus"></i> Tambah data</a>
            </div>
        </div>
        <table class="table">
            <thead>
                <tr>
                    <th scope="col" width="5%">#</th>
                    <th scope="col" width="30%">Nama siswa</th>
                    <th scope="col" width="20%">Kelas</th>
                    <th width="25%" class="text-center">Nilai rata-rata</th>
                    <th scope="col" width="20%" class="text-center">Aksi</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($data as $item)
                    <tr>
                        <th scope="row">{{ $loop->iteration }}</th>
                        <td>{{ $item->name }}</td>
                        <td>{{ $item->classroom->name }}</td>
                        @if ($item->grades)
                            
                        <td class="text-center">{{$item->grades->sum('total') / $total_subject}}</td>
                        @endif
                        <td class="text-center">
                            <a href="{{ route('student.show',$item->id) }}" class="btn btn-sm btn-light border">  Detail nilai</a>
                            <a href="{{ route('student.edit',$item->id) }}" class="btn btn-sm btn-secondary text-uppercase"> <i class="fa fa-edit"></i></a>
                            
                            <form class="d-inline" action="{{ route('student.destroy',$item->id) }}" method="post">
                                @csrf
                                @method('delete')
                                <button class="btn btn-sm btn-danger"> <i class="fa fa-trash"></i></button>
                            </form>
                        </td>
                    </tr>
                @endforeach

            </tbody>
        </table>
    </div>
@endsection

resources/views/backoffice/student/show.blade.php
@extends('layouts.backoffice')
@section('title', 'Detail siswa')
@section('content')

    <div class="container-fluid p-4">
        <h4 class="mt-4">Detail siswa</h4>
        @if (session()->has('msg'))
            
        <div class="alert alert-success alert-dismissible fade show" role="alert">
            {{ session()->get('msg')}}
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
        @endif
        <div class="row my-3 text-secondary">
            <h5> Nama : {{ $data->name }}</h5>
            <p> Kelas : {{ $data->classroom->name}}</p>
        </div>
        
        <div class="row justify-content-between my-3">
            
            <div class="col-lg-2">

                <a href="{{ route('student.index') }}" class="btn btn-secondary"> <i class="fa fa-arrow-left"></i> Kembali</a>
            </div>
            
            @if ($total_subject > $data->grades->count())
            <div class="col-lg-2">

                <a href="{{ route('grade.create',['id'=>$data->id]) }}" class="btn btn-primary"> <i class="fa fa-plus"></i> Tambah nilai</a>
            </div>
            @endif
        </div>

        <table class="table">
            <thead>
                <tr>
                    <th scope="col" width="70%">Mapel</th>
                    <th width="10%"> Total nilai</th>
                    <th scope="col" width="20%" class="text-center">Aksi</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($data->grades as $item)
                    <tr>
                        <th scope="row">{{ $item->subject->name }}</th>
                        <td class="text-center">{{ $item->total }}</td>
                        <td class="text-center">
                            <a href="{{ route('grade.edit',$item->id) }}?id={{$data->id }}" class="btn btn-sm btn-secondary text-uppercase"> <i class="fa fa-edit"></i></a>
                        </td>
                    </tr>
                @empty
                <tr>
                    <th colspan="3" class="text-center"> <h4>Nilai belum diinput</h4></th>
                </tr>
                @endforelse
                <tr class="border-white">
                    <th colspan="1" class="text-end">Total nilai </th>
                    <td class="text-center">{{ $data->grades->sum('total') }}</td>
                    <td></td>
                </tr>
                <tr class="border-white">
                    <th colspan="1" class="text-end">Rata - rata </th>
                    <td class="text-center">{{ $data->grades->sum('total') / $total_subject }}</td>
                    <td></td>
                </tr>

            </tbody>
        </table>
    </div>
@endsection